import matplotlib.pyplot as plt
import numpy as np
import sys

fig = plt.figure()
#ax1 = fig.add_subplot(121)
#ax2 = fig.add_subplot(122)
#ax1 = fig.add_subplot(131)
#plt.grid()
#ax2 = fig.add_subplot(132)
#plt.grid()
ax3 = fig.add_subplot(111)
plt.grid(linestyle = '-.')
n = np.array([128, 192, 256, 384, 512, 768, 1024, 1536, 2048, 3072, 4096, 6144, 8192, 12288, 16384])
t1 = np.array([0.00113606, 0.00172305, 0.00136399, 0.00225687, 0.00144601 , 0.00140595, 0.00140405, 0.00181890 , 0.00169301, 0.00319886, 0.00378609, 0.00440478 , 0.00379896 , 0.00696087,  0.00787902])

t2 = np.array([0.00164604, 0.00158310 , 0.00131702, 0.00130606, 0.00121117, 0.00229192, 0.00281811, 0.00200200, 0.00166893, 0.00276899, 0.00242114, 0.00306702, 0.00380111, 0.00563097, 0.00725698])

t3 = np.array([0.00238895, 0.00218010 , 0.00156903, 0.00121498, 0.00129414, 0.00237203, 0.00174308, 0.00164580, 0.00170398, 0.00202203, 0.00280190 , 0.00342393,  0.00380182, 0.00545311, 0.00817585])


t4 = np.array([0.00105596, 0.00106406, 0.00109506 , 0.00185013, 0.00131583, 0.00134206, 0.00133181, 0.00146294 , 0.00161791, 0.00210881, 0.00236893, 0.00300813, 0.00354600, 0.00528097, 0.00710988])


t5 = np.array([0.00107408, 0.00112200, 0.00124097, 0.00118208 , 0.00120282, 0.00130010, 0.00137115, 0.00151610, 0.00171614, 0.00220513, 0.00245810, 0.00321889, 0.00406814, 0.00605893, 0.00789189])


#t = np.array([0.00924, 0.01045, 0.01292, 0.02098, 0.054, 0.01018, 0.01123, 0.01619, 0.03378, 0.09958, 0.35205, 0.72432, 2.08221, 12.5630, 8.24977])
#t = np.sort(t)
#ax1.plot(n, t)
##ax2.plot(np.linspace(0, n.size-1, n.size), n/t / np.max(n/t), 'r')
#ax2.plot(np.log2(n), n/t / np.max(n/t), 'r')
#ax2.plot(np.log2(n), t, 'r')
ax3.plot(n, 5*n**2/(t1+t2+t3+t4+t5)/10**9 , 'r')
#ax3.plot(n**2, t, 'g')

print(np.max(5*n**2/(t1+t2+t3+t4+t5)) / 10**9)
plt.title('Зависимость производительности от размера матрицы')
plt.xlabel('Размер матрицы')
plt.ylabel('Производительность, Gflops/s')
plt.show()
fig.savefig('kek.png')
